<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>ReactJS</title>
    <script crossorigin src="https://unpkg.com/react@17.0.0/umd/react.production.min.js"></script>
    <script crossorigin src="https://unpkg.com/react-dom@17.0.0/umd/react-dom.production.min.js"></script>
    <script src="https://unpkg.com/babel-standalone@6/babel.min.js"></script>
    <!-- Link lay thu vien ReactJS -->
    <!-- https://legacy.reactjs.org/docs/add-react-to-a-website.html -->
</head>

<body>
    <!-- <h1>ECMAScript 6 - ECMAScript 2015 - ES6</h1> -->
    <div id="root"></div>
</body>
<!-- <script type="module" src="app.js"></script> -->
<!-- <script>
    const h1 = document.createElement('h1');
    h1.innerText = "Hello guys!";
    h1.id = 'heading';
    h1.className = 'text-center';
    // h1.style = 'color:red;font-size=1rem';

    Object.assign(h1.style, {
        color: 'blue',
        fontSize: '10rem',
        backgroundColor: '#333'
    })

    document.body.appendChild(h1);
    console.log(h1);

</script> -->
<!-- <script type="text/babel">
    //DOM
    // const h1DOM = document.createElement('h1');

    // h1DOM.innerText = 'Hello guys!';
    // h1DOM.title = 'Hello';
    // h1DOM.className = 'heading';

    // document.body.appendChild(h1DOM);
    // console.log(h1DOM);

    // const ulDOM = document.createElement('ul');
    // ulDOM.id = 'ul-id';
    // ulDOM.style = "color:red;font-size:30px";

    // const li1DOM = document.createElement('li');
    // li1DOM.innerText = 'Javascript';
    // li1DOM.id = 'li-1';

    // const li2DOM = document.createElement('li');
    // li2DOM.innerText = 'ReactJS';

    // ulDOM.appendChild(li1DOM);
    // ulDOM.appendChild(li2DOM);

    // console.log(ulDOM);
    // document.body.appendChild(ulDOM);

    // const divDOM = document.createElement('div');
    // divDOM.className = 'post-item';

    // const h2DOM = document.createElement('h2');
    // h2DOM.title = 'Học React tại F8';
    // h2DOM.innerText = 'Học ReactJS';

    // const pDOM = document.createElement('p');
    // pDOM.innerText = 'Học ReactJS từ cơ bản tới nâng cao';

    // divDOM.appendChild(h2DOM);
    // divDOM.appendChild(pDOM);

    // document.body.appendChild(divDOM);
    // console.log(divDOM);

    // React -> React-DOM

    // const h1React = React.createElement('h1', {
    //     title: 'Hello',
    //     className: 'heading',
    // }, 'Hello guys!');
    // console.dir(h1React);

    // const h1React = React.createElement('h1', {
    //     title: 'Hello',
    //     className: 'heading',
    // }, 'Hello guys!');



    // ReactDOM.render(h1React, root);

    // const ulReact = React.createElement(
    //     React.Fragment,
    //     {
    //         id: "ul-id",
    //         style: "color:red;font-size:30px;"
    //     },
    //     React.createElement('li', { id: 'li-1' }, 'Javascript'),
    //     React.createElement('li', null, 'ReactJS')
    // );
    // //Get root element
    // const container = document.getElementById('root');


    // const ulReact = React.createElement(
    //     'ul',
    //     null,
    //     React.createElement('li', null, 'Javascript'),
    //     React.createElement('li', null, 'ReactJS'),
    // );

    // ReactDOM.render(ulReact, container);

    // console.log(ulReact);

    // const postItem = React.createElement(
    //     'div',
    //     {
    //         className: 'post-item'
    //     },
    //     React.createElement('h2', { title: 'Học React tại F8' }, 'Học ReactJS'),
    //     React.createElement('p', {}, 'Học ReactJS từ cơ bản tới nâng cao')
    // )


    // const root = ReactDOM.createRoot(container);

    // root.render(postItem);
    // //React-DOM -> render UI

    // const courses = [
    //     {
    //         name: 'HTML, CSS'
    //     },
    //     {
    //         name: 'Responsive web design'
    //     },
    //     {
    //         name: 'ReactJS'
    //     }
    // ]

    // const ulReact = <ul>
    //     {courses.map(course => <li>{course.name}</li>)}
    // </ul>
    // const double = (<React.Fragment>
    //     <h1>Heading 1</h1>
    //     <h2>Heading 2</h2>
    // </React.Fragment>)
    //Get root element
    const container = document.getElementById('root');

    ReactDOM.render(ulReact, container);



</script> -->
<!-- <script type="text/babel">

    // function Header() {
    //     return (<div className="header">New Header</div>)
    // }

    // class Content extends React.Component {
    //     render() {
    //         return (<div className="content">New Content</div>)
    //     }
    // }

    // const app = (
    //     <div className="wrapper">
    //         <Header />
    //         <Content />
    //         <div className="footer">Footer</div>
    //     </div>
    // )

    // PostItem.js
    // function PostItem(props) {
    //     return (
    //         <div className="post-item">
    //             <img src={props.image} />
    //             <h2 className="post-title">{props.title}</h2>
    //             <p className="post-desc">{props.description}</p>
    //             <p className="post-published">{props.publishedAt}</p>
    //         </div>
    //     )
    // }

    //App.js
    // function App() {
    //     return (
    //         <div id="wrapper">
    //             <PostItem
    //                 title="C#(.NET) - Tương tác với file Excel"
    //                 image="https://kimnhungtoeic.com/wp-content/uploads/2023/07/dap-an-test-1-ets-2023.jpg" alt="C#(.NET) - Tương tác với file Excel"
    //                 description="Bạn có kiến thức ngôn ngữ C#! Bạn muốn thực hiện tương tác với file excel"
    //                 publishedAt="Một ngày trước . 5 phút đọc"
    //             />
    //         </div>
    //     )
    // }

    // index.js
    // ReactDOM.render(<App />, document.getElementById('root'));



    // const app = (
    //     <div className="posts-list">
    //         <PostItem />
    //     </div>
    // )

    // const courses = [
    //     {
    //         "id": 15,
    //         "title": "HTML CSS Pro",
    //         "slug": "htmlcss",
    //         "description": "Từ cơ bản tới chuyên sâu, thực hành 8 dự án, hàng trăm bài tập, trang hỏi đáp riêng, cấp chứng chỉ sau khóa học và mua một lần học mãi mãi.",
    //         "image": "courses/15/62f13d2424a47.png",
    //         "icon": "courses/15/62385d6c63dfa.png",
    //         "video_type": "upload",
    //         "video": null,
    //         "old_price": 2500000,
    //         "price": 1299000,
    //         "pre_order_price": 699000,
    //         "students_count": 3837,
    //         "is_pro": true,
    //         "is_coming_soon": false,
    //         "is_selling": true,
    //         "published_at": "2022-08-18T17:00:00.000000Z",
    //         "is_registered": false,
    //         "user_progress": 0,
    //         "last_completed_at": null,
    //         "image_url": "https://files.fullstack.edu.vn/f8-prod/courses/15/62f13d2424a47.png",
    //         "icon_url": "https://files.fullstack.edu.vn/f8-prod/courses/15/62385d6c63dfa.png",
    //         "video_url": "",
    //         "landing_page_url": "/landing/htmlcss",
    //         "is_pre_order": false,
    //         "is_published": true
    //     },
    //     {
    //         "id": 27,
    //         "title": "Ngôn ngữ tiền xử lý Sass",
    //         "slug": "sass",
    //         "description": "Đây là một khóa học nhỏ được tách ra từ 2 chương học trong khóa HTML CSS Pro. Kiến thức về Sass trong khóa này bạn có thể áp dụng ngay vào các dự án của bạn.",
    //         "image": "courses/27/64e184ee5d7a2.png",
    //         "icon": "courses/27/64e0daf212fad.png",
    //         "video_type": "upload",
    //         "video": "courses/27/oeT5zTmdk8KlHwU2meMJpnR7uihkX6OvYxnkjiB9.mp4",
    //         "old_price": 400000,
    //         "price": 299000,
    //         "pre_order_price": 0,
    //         "students_count": 0,
    //         "is_pro": true,
    //         "is_coming_soon": false,
    //         "is_selling": true,
    //         "published_at": "2023-08-19T15:06:00.000000Z",
    //         "is_registered": false,
    //         "user_progress": 0,
    //         "last_completed_at": null,
    //         "image_url": "https://files.fullstack.edu.vn/f8-prod/courses/27/64e184ee5d7a2.png",
    //         "icon_url": "https://files.fullstack.edu.vn/f8-prod/courses/27/64e0daf212fad.png",
    //         "video_url": "https://videos.fullstack.edu.vn/f8-prod/courses/27/oeT5zTmdk8KlHwU2meMJpnR7uihkX6OvYxnkjiB9.mp4",
    //         "landing_page_url": "/landing/sass",
    //         "is_pre_order": false,
    //         "is_published": true
    //     },
    //     {
    //         "id": 19,
    //         "title": "JavaScript Pro",
    //         "slug": "javascript-pro",
    //         "description": "Khóa học JavaScript Pro",
    //         "image": "courses/19/62f13cb607b4b.png",
    //         "icon": "courses/19/62f13cb685c81.png",
    //         "video_type": "upload",
    //         "video": null,
    //         "old_price": 0,
    //         "price": 0,
    //         "pre_order_price": 0,
    //         "students_count": 0,
    //         "is_pro": true,
    //         "is_coming_soon": true,
    //         "is_selling": false,
    //         "published_at": "2023-11-30T17:00:00.000000Z",
    //         "is_registered": false,
    //         "user_progress": 0,
    //         "last_completed_at": null,
    //         "image_url": "https://files.fullstack.edu.vn/f8-prod/courses/19/62f13cb607b4b.png",
    //         "icon_url": "https://files.fullstack.edu.vn/f8-prod/courses/19/62f13cb685c81.png",
    //         "video_url": "",
    //         "landing_page_url": "/landing/javascript-pro",
    //         "is_pre_order": false,
    //         "is_published": false
    //     },
    //     {
    //         "id": 20,
    //         "title": "NextJS Pro",
    //         "slug": "reactjs-pro",
    //         "description": "Khóa học NextJS Pro",
    //         "image": "courses/20/648020fc16597.png",
    //         "icon": "courses/20/648020fcc8000.png",
    //         "video_type": "upload",
    //         "video": null,
    //         "old_price": 0,
    //         "price": 0,
    //         "pre_order_price": 0,
    //         "students_count": 0,
    //         "is_pro": true,
    //         "is_coming_soon": true,
    //         "is_selling": false,
    //         "published_at": "2024-03-31T17:00:00.000000Z",
    //         "is_registered": false,
    //         "user_progress": 0,
    //         "last_completed_at": null,
    //         "image_url": "https://files.fullstack.edu.vn/f8-prod/courses/20/648020fc16597.png",
    //         "icon_url": "https://files.fullstack.edu.vn/f8-prod/courses/20/648020fcc8000.png",
    //         "video_url": "",
    //         "landing_page_url": "/landing/reactjs-pro",
    //         "is_pre_order": false,
    //         "is_published": false
    //     }
    // ]

    

    //App.js
    // function App() {
    //     return (
    //         <div id="wrapper">
    //             {courses.map(course => (
    //                 <CourseItem
    //                     key={course.id}
    //                     // title={course.title}
    //                     // image={course.image_url}
    //                     // description={course.description}
    //                     // studentsCount={course.students_count}
    //                     course={course}
    //                 />
    //             ))
    //             }
    //         </div>
    //     )
    // }

    // ReactDOM.render(<App />, document.getElementById('root'));

</script> -->
<!-- <script type="text/babel">
    //App.js
    // function App() {
    //     return (
    //         <div id="wrapper">
    //             <button onClick={(event) => console.log(event.target)}
    //             >
    //                 Click Me!
    //             </button>
    //         </div>
    //     )
    // }

    const courses = [
        {
            "id": 15,
            "title": "HTML CSS Pro",
            "slug": "htmlcss",
            "description": "Từ cơ bản tới chuyên sâu, thực hành 8 dự án, hàng trăm bài tập, trang hỏi đáp riêng, cấp chứng chỉ sau khóa học và mua một lần học mãi mãi.",
            "image": "courses/15/62f13d2424a47.png",
            "icon": "courses/15/62385d6c63dfa.png",
            "video_type": "upload",
            "video": null,
            "old_price": 2500000,
            "price": 1299000,
            "pre_order_price": 699000,
            "students_count": 3837,
            "is_pro": true,
            "is_coming_soon": false,
            "is_selling": true,
            "published_at": "2022-08-18T17:00:00.000000Z",
            "is_registered": false,
            "user_progress": 0,
            "last_completed_at": null,
            "image_url": "https://files.fullstack.edu.vn/f8-prod/courses/15/62f13d2424a47.png",
            "icon_url": "https://files.fullstack.edu.vn/f8-prod/courses/15/62385d6c63dfa.png",
            "video_url": "",
            "landing_page_url": "/landing/htmlcss",
            "is_pre_order": false,
            "is_published": true
        },
        {
            "id": 27,
            "title": "Ngôn ngữ tiền xử lý Sass",
            "slug": "sass",
            "description": "Đây là một khóa học nhỏ được tách ra từ 2 chương học trong khóa HTML CSS Pro. Kiến thức về Sass trong khóa này bạn có thể áp dụng ngay vào các dự án của bạn.",
            "image": "courses/27/64e184ee5d7a2.png",
            "icon": "courses/27/64e0daf212fad.png",
            "video_type": "upload",
            "video": "courses/27/oeT5zTmdk8KlHwU2meMJpnR7uihkX6OvYxnkjiB9.mp4",
            "old_price": 400000,
            "price": 299000,
            "pre_order_price": 0,
            "students_count": 0,
            "is_pro": true,
            "is_coming_soon": false,
            "is_selling": true,
            "published_at": "2023-08-19T15:06:00.000000Z",
            "is_registered": false,
            "user_progress": 0,
            "last_completed_at": null,
            "image_url": "https://files.fullstack.edu.vn/f8-prod/courses/27/64e184ee5d7a2.png",
            "icon_url": "https://files.fullstack.edu.vn/f8-prod/courses/27/64e0daf212fad.png",
            "video_url": "https://videos.fullstack.edu.vn/f8-prod/courses/27/oeT5zTmdk8KlHwU2meMJpnR7uihkX6OvYxnkjiB9.mp4",
            "landing_page_url": "/landing/sass",
            "is_pre_order": false,
            "is_published": true
        },
        {
            "id": 19,
            "title": "JavaScript Pro",
            "slug": "javascript-pro",
            "description": "Khóa học JavaScript Pro",
            "image": "courses/19/62f13cb607b4b.png",
            "icon": "courses/19/62f13cb685c81.png",
            "video_type": "upload",
            "video": null,
            "old_price": 0,
            "price": 0,
            "pre_order_price": 0,
            "students_count": 0,
            "is_pro": true,
            "is_coming_soon": true,
            "is_selling": false,
            "published_at": "2023-11-30T17:00:00.000000Z",
            "is_registered": false,
            "user_progress": 0,
            "last_completed_at": null,
            "image_url": "https://files.fullstack.edu.vn/f8-prod/courses/19/62f13cb607b4b.png",
            "icon_url": "https://files.fullstack.edu.vn/f8-prod/courses/19/62f13cb685c81.png",
            "video_url": "",
            "landing_page_url": "/landing/javascript-pro",
            "is_pre_order": false,
            "is_published": false
        },
        {
            "id": 20,
            "title": "NextJS Pro",
            "slug": "reactjs-pro",
            "description": "Khóa học NextJS Pro",
            "image": "courses/20/648020fc16597.png",
            "icon": "courses/20/648020fcc8000.png",
            "video_type": "upload",
            "video": null,
            "old_price": 0,
            "price": 0,
            "pre_order_price": 0,
            "students_count": 0,
            "is_pro": true,
            "is_coming_soon": true,
            "is_selling": false,
            "published_at": "2024-03-31T17:00:00.000000Z",
            "is_registered": false,
            "user_progress": 0,
            "last_completed_at": null,
            "image_url": "https://files.fullstack.edu.vn/f8-prod/courses/20/648020fc16597.png",
            "icon_url": "https://files.fullstack.edu.vn/f8-prod/courses/20/648020fcc8000.png",
            "video_url": "",
            "landing_page_url": "/landing/reactjs-pro",
            "is_pre_order": false,
            "is_published": false
        }
    ]


    // CourseItem, UI component: chỉ hiển thị k thực hiện logic
    function CourseItem({ course, onClick }) {
        return (
            <div>
                <h2 onClick={() => onClick(course)}>{course.title}</h2>
                <img src={course.image_url} />
                <p>{course.description}</p>
                <p>{course.students_count}</p>
            </div>
        )
    }

    //Container
    function App() {
        //useCallback
        const handleClick = (course) => {
            alert(course.title)
        }

        return (
            <div id="wrapper">
                {
                    courses.map(course => (
                        <CourseItem
                            key={course.id}
                            course={course}
                            onClick={handleClick}
                        />
                    ))
                }

            </div>
        )
    }

    ReactDOM.render(<App />, document.getElementById("root"));
</script> -->


<!-- <script type="text/babel">

    function Button({ title, href, onClick }) {
        let Component = 'button'
        const props = {}

        if (href) {
            props.href = href;
            Component = 'a'
        }

        if (onClick) {
            props.onClick = onClick;
        }

        return (
            <Component {...props} > {title}</Component >
        )
    }

    function App() {
        return (
            <div id="wrapper">
                <Button
                    title="Click me!"
                    href="https://fullstack.edu.vn/"
                    onClick={() => console.log(Math.ramdom())}
                />
            </div>
        )

        reactDOM.render(<App />, document.getElementById('root'))
    }
</script> -->

<script type="text/babel">
    function Button({ title }) {
        return <button>{title}</button>
    }

    function App() {
        return (
            <div id="wrapper">
                <Button title="Click me!" />
            </div>
        )
    }

    ReactDOM.render(<App />, document.getElementById('root'))
</script>

</html>